//=================================
// Widget interface
//=================================
var _sys = null;
if($.browser.msie && window.System){
	_sys = getWidgetIfaceWin();
} else if($.browser.webkit){
	if(window.widget){
		_sys = getWidgetIfaceMac();
	}else{
		_sys = getWidgetIfaceDbgMac();
	}
}
if(_sys == null){
	_sys = getWidgetIfaceDbgWin();
}
//=================================
// Localization
//=================================
var _daysort = ["сегодня","вчера","позавчера","3 дня назад","4 дня назад", " дней назад"];
var _weekdays_short = ["вс","пн","вт","ср","чт","пт","сб"];
var _weekdays_long = ["воскресенье","понедельник","вторник","среда","четверг","пятница","суббота"];
var _months_long = ["января","февраля","марта","апреля","мая","июня","июля","августа","сентября","октября","ноября","декабря"];
var _months_short = ["янв.","фев.","марта","апр.","мая","июня","июля","авг.","сен.","окт.","нояб.","дек."];
var _inprogress_img = "<img width='16' height='16' src='static/images/ajax-loading-small.gif'/>";
var _inprogress2_img = "<img width='16' height='5' src='static/images/ajax-loading-micro.gif' style='position: relative; top: -2px; left: 3px;'/>";
var isUpdloc = 0;
function updateLocalizations() {
	if(isUpdloc>0){
		return;
	}
	isUpdloc++;
	var locars = [_daysort,_weekdays_short,_weekdays_long,_months_long,_months_short];
	for(var i=0;i<locars.length;i++){
		for(var j=0;j<locars[i].length;j++){
			locars[i][j] = $._b(locars[i][j]);
		}
	}
}
//=================================
// Local data
//=================================
var gadgetMaxPagesToShow = 5;
var gadgetRefreshRate_ms = 5*60*1000;//10000;
var gadgetCheckVersion_ms = 24*60*60*1000;//20000;
var gadgetMaxTitleChars = 20;
var gadgetBottomZazor = 0;
var gadgetDefaultBackdays = 1;
var gadgetDivWindows = ["userForm_info","loginForm_userinput","alert_container","loginForm_inprogress"];
var gadgetVisuals = [
	 {undocked:false, ww: 130, hh: 295, margins: [ 0, 0, 0, 0], src:"windows-gadget-docked-2.png", for_window: ["userForm_info"], drink_rows: [0,1,2], visible_rows: 2, title_chars: 13, max_dayback: 22, chart_hh: 119}
	,{undocked:true, ww: 190, hh: 336, margins: [ 8, 8, 10, 8], src:"windows-gadget-undocked-2.png", for_window: ["userForm_info"], drink_rows: [0,1,2], visible_rows: 2, title_chars: 20, max_dayback: 33, chart_hh: 116}
	,{undocked:false, ww: 130, hh: 321, margins: [ 0, 0, 0, 0], src:"windows-gadget-docked-3.png", for_window: ["userForm_info"], drink_rows: [3], visible_rows: 3, title_chars: 13, max_dayback: 22, chart_hh: 119}
	,{undocked:true, ww: 190, hh: 362, margins: [ 8, 8, 10, 8], src:"windows-gadget-undocked-3.png", for_window: ["userForm_info"], drink_rows: [3], visible_rows: 3, title_chars: 20, max_dayback: 33, chart_hh: 116}
	,{undocked:false, ww: 130, hh: 347, margins: [ 0, 0, 0, 0], src:"windows-gadget-docked-4.png", for_window: ["userForm_info"], drink_rows: [4], visible_rows: 4, title_chars: 13, max_dayback: 22, chart_hh: 119}
	,{undocked:true, ww: 190, hh: 388, margins: [ 8, 8, 10, 8], src:"windows-gadget-undocked-4.png", for_window: ["userForm_info"], drink_rows: [4], visible_rows: 4, title_chars: 20, max_dayback: 33, chart_hh: 116}
	,{undocked:false, ww: 130, hh: 373, margins: [ 0, 0, 0, 0], src:"windows-gadget-docked-5.png", for_window: ["userForm_info"], drink_rows: [5], visible_rows: 5, title_chars: 13, max_dayback: 22, chart_hh: 119}
	,{undocked:true, ww: 190, hh: 414, margins: [ 8, 8, 10, 8], src:"windows-gadget-undocked-5.png", for_window: ["userForm_info"], drink_rows: [5], visible_rows: 5, title_chars: 20, max_dayback: 33, chart_hh: 116}
	,{undocked:false, ww: 130, hh: 399, margins: [ 0, 0, 0, 0], src:"windows-gadget-docked-6.png", for_window: ["userForm_info"], drink_rows: [-1], visible_rows: 6, title_chars: 13, max_dayback: 22, chart_hh: 119}
	,{undocked:true, ww: 190, hh: 440, margins: [ 8, 8, 10, 8], src:"windows-gadget-undocked-6.png", for_window: ["userForm_info"], drink_rows: [-1], visible_rows: 6, title_chars: 20, max_dayback: 33, chart_hh: 116}
	
	,{undocked:false, ww: 130, hh: 241, margins: [ 0, 0, 0, 0], src:"windows-gadget-docked-authorizing.png", for_window: ["loginForm_userinput","alert_container","loginForm_inprogress"]}
	,{undocked:true, ww: 190, hh: 360, margins: [ 8, 8, 14+100, 8], src:"windows-gadget-undocked-authorizing.png", for_window: ["loginForm_userinput","alert_container","loginForm_inprogress"]}
	
	,{ww: 190, hh: 414, margins: [ 8, 8, 10, 8], src:"mac-widget-settings.png", for_window: ["macOptions"]}
];

//=================================
// Consts
//=================================
var _black_slider_point = 300;
var _greenzone_point = 20;
var _chart_colorizer_from_point = 150;
var _chart_downscaler = 0.85;
var _day_in_sec = 86400;
var _daynow = new Date();
var _login_type_showForm = -1;
var _login_type_knownUser = 0;
var _login_type_tempUser = 1;
var _error_no_connection = "conn_err";// Local
var _error_server_down = "server_err";// Local
var _error_no_auth = "auth_failed";// From API
var _error_no_auth2 = "auth_failed2";// Local
var _error_invalid_data = "invalid_data";// Local
var _postoption_action_nop = 0;
var _postoption_action_do_rope = 1;
var _postoption_action_show_psw_err = 2;

//=================================
// Save/Load settings
//=================================
var user_login_type = null;
var user_login_email = null;
var user_login_passw = null;
var user_auth_token = "";
var user_auth_token_prev = "";
var user_postoption_action = _postoption_action_nop;
var user_show_greenzone = null;
function readSettings() {
	user_login_type = coalesce(_sys.getLocalSetting("login_type"),_login_type_showForm);
	user_login_email = coalesce(_sys.getLocalSetting("user_login"),"");
	user_login_passw = coalesce(_sys.getLocalSetting("user_password"),"");
	user_auth_token = coalesce(_sys.getLocalSetting("auth_token"),"");
	user_auth_token_prev = coalesce(_sys.getLocalSetting("auth_token_prev"),"");
	user_show_greenzone = coalesce(_sys.getLocalSetting("show_greenzone"),0);
	user_postoption_action = coalesce(_sys.getLocalSetting("postoption_action"),_postoption_action_nop);
}
