//===============
var gDoneButton = null;
var gInfoButton = null;
var isInOptions = false;
var isDashboardOn = false;
function showPrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget){
		widget.prepareForTransition("ToBack");
	}
	front.style.display="none";
	back.style.display="block";
	isInOptions = true;
	mainOptions();
	xlog("showPrefs: isInOptions="+isInOptions);
	updateGadget();
	if (window.widget){
		setTimeout ('widget.performTransition();', 2);
		setTimeout ('redrawWidgetAfterTransition();', 2000);
	}
}
function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	if (window.widget){
		widget.prepareForTransition("ToFront");
	}
	back.style.display="none";
	front.style.display="block";
	isInOptions = false;
	postpareSettings();
	finalizeSettings();
	xlog("hidePrefs: isInOptions="+isInOptions);
	updateGadget();
	if (window.widget){
		setTimeout ('widget.performTransition();', 2);
		setTimeout ('redrawWidgetAfterTransition();', 2000);
	}
}
//====================
var growboxInset;
function mac_resizeMouseDown(event)
{
	document.addEventListener("mousemove", mac_resizeMouseMove, true);
	document.addEventListener("mouseup", mac_resizeMouseUp, true);
	growboxInset = {x:(window.innerWidth - event.x), y:(window.innerHeight - event.y)};
	event.stopPropagation();
	event.preventDefault();
}
var last_w = 0;
function mac_resizeMouseMove(event)
{
	var x = event.x + growboxInset.x;
	var y = event.y + growboxInset.y;
	last_w = y;
	updateGadget();
	event.stopPropagation();
	event.preventDefault();
}
function mac_resizeMouseUp(event)
{
	document.removeEventListener("mousemove", mac_resizeMouseMove, true);
	document.removeEventListener("mouseup", mac_resizeMouseUp, true);
	event.stopPropagation();
	event.preventDefault();
}

function mac_onDashboardHide() {
	isDashboardOn = false;
}
function mac_onDashboardShow() {
	isDashboardOn = true;
	mac_reloadData();
}
var updatesTimerOk = false;
function mac_reloadData() {
	if(!isUserLoggedIn()){
		return;
	}
	if(isDashboardOn){
		reloadData();
	}
}
var mac_lastVisualDeff = null;
function mac_applyWidgetVisual(visualDefinition) {
	xlog("mac_applyWidgetVisual: instance="+mac_getWidgetUid()+", isInOptions="+isInOptions);
	if(isInOptions){
		visualDefinition = updateGadget_findProperBg("macOptions");
	}

	visualDefinition.margins = coalesce(visualDefinition.margins,[]);
	var margint = coalesce(visualDefinition.margins[0],0);
	var marginr = coalesce(visualDefinition.margins[1],0);
	var marginb = coalesce(visualDefinition.margins[2],0);
	var marginl = coalesce(visualDefinition.margins[3],0);
	
	var src = visualDefinition.src;
	$('#gadgetContent').css('background-image', "url('static/images/"+src+"')");
	$('#gadgetContent').css('width', visualDefinition.ww-marginl-marginr).css('height', visualDefinition.hh-margint-marginb);
	$('#gadgetContent').css('padding-left',marginl).css('padding-top',margint);
	$('#gadgetContent').css('padding-right',marginr).css('padding-bottom',marginb);
	$(document.body).css('width', visualDefinition.ww).css('height', visualDefinition.hh);
	
	$('#optionsContent').css('background-image', "url('static/images/"+src+"')");
	$('#optionsContent').css('width', visualDefinition.ww-marginl-marginr).css('height', visualDefinition.hh-margint-marginb);
	$('#optionsContent').css('padding-left',marginl).css('padding-top',margint);
	$('#optionsContent').css('padding-right',marginr).css('padding-bottom',marginb);
	
	if(!_sys.isDebug()){
		mac_lastVisualDeff = visualDefinition;
		ww = visualDefinition.ww;
		hh = visualDefinition.hh;
		window.resizeTo( ww, hh );
		setDivPos('#resize', ww - marginr, hh - marginb);
		setDivPos('#infoButton', ww - 20 - marginr, hh - 20 - marginb);
		if(isInOptions){
			setDivPos('#doneButton', 55, hh - 45 - marginb);
		}
	}
	if(updatesTimerOk == false){
		xlog("mac_applyWidgetVisual: updatesTimerOk==false");
		updatesTimerOk = true;
		setInterval(reloadData,gadgetRefreshRate_ms);
	}
}
function redrawWidgetAfterTransition(){
	//if(!_sys.isDebug() && mac_lastVisualDeff!=null)
	{
		//$('#main_body').css('top', mac_lastVisualDeff.hh+1 );
		//$('#main_body').css('top', mac_lastVisualDeff.hh+0 );
	}
}
function mac_reloadGadget() {
	//location.href = location.href;
	setTimeout ('main();', 0);
}
function mac_OpenUrl(url)
{
	widget.openURL(url);
}
function mac_getHostOverloads()
{
	return {
	};
}
//===============================
function mac_getWidgetUid()
{
	if(!_sys.isDebug()){
		return widget.identifier;
	}
	return "dbg";
}
// Wrapping to json since widget support string-only preferences
function mac_setLocalSetting(name,value)
{
	if(value == null){
		return;
	}
	//NO!! recursion: xlog("mac_setLocalSetting name="+name+"; value="+value+"; wid="+mac_getWidgetUid());
	widget.setPreferenceForKey($.toJSON(value), name+"_"+mac_getWidgetUid());
}
// do not forget to unwrap from json!
function mac_getLocalSetting(name)
{
	var value =  widget.preferenceForKey(name+"_"+mac_getWidgetUid());
	//NO!! recursion: xlog("mac_getLocalSetting name="+name+"; value="+(value?value:"null")+"; wid="+mac_getWidgetUid());
	if(value == null){
		return null;
	}
	return $.evalJSON(value);
}
//===============================
function mac_DoStartup()
{
	if(_sys.isDebug()){
		//server_api_url = server_api_url_dbg2;
		gadgetRefreshRate_ms = 10000;
		gadgetCheckVersion_ms = 20000;
	}
	if(!_sys.isDebug()){
		widget.onhide = mac_onDashboardHide;
		widget.onshow = mac_onDashboardShow;
		if(gDoneButton == null){
			gDoneButton = new AppleGlassButton(document.getElementById("doneButton"), $._b("Сохранить"), hidePrefs);
		}
		if(gInfoButton == null){
			gInfoButton = new AppleInfoButton(document.getElementById("infoButton"), document.getElementById("front"), "black", "black", showPrefs);
		}
	}
}
