// Gadget settings wrapper
// Should be called on OK
function finalizeSettings() {
	//xlog("===finalizeSettings 1===");
	readSettings();
	// Reading action settings
	settings_act_disrope = _sys.getLocalSetting("settings_act_disrope");
	settings_act_rope = _sys.getLocalSetting("settings_act_rope");
	settings_act_rope_login = _sys.getLocalSetting("settings_act_rope_login");
	settings_act_rope_password = _sys.getLocalSetting("settings_act_rope_password");
	if(settings_act_disrope == 0){
		_sys.setLocalSetting("auth_token","");
		_sys.setLocalSetting("auth_token_prev",user_auth_token);
		_sys.setLocalSetting("user_login","");
		_sys.setLocalSetting("user_password","");
		_sys.setLocalSetting("login_type",_login_type_tempUser);
		_sys.setLocalSetting("postoption_action",_postoption_action_nop);
		_sys.restartWidget();
		return;
	}
	if(settings_act_rope > 0){
		if(settings_act_rope_login != ""){
			if(settings_act_rope_password == ""){
				showMessage($._b("LABEL.LOGIN_PASSW_INCORRECT"));
				return;
			}
			_sys.setLocalSetting("auth_token","");
			_sys.setLocalSetting("auth_token_prev",user_auth_token);
			_sys.setLocalSetting("login_type",_login_type_knownUser);
			_sys.setLocalSetting("user_login",settings_act_rope_login);
			_sys.setLocalSetting("user_password",settings_act_rope_password);
			_sys.setLocalSetting("postoption_action",_postoption_action_do_rope);
			_sys.restartWidget();
			return;
		}
	}
	if(user_current_entry >= 0){
		showUserChart();
	}
	//xlog("===finalizeSettings 2===");
}
// Should be called before closing options
function postpareSettings() {
	//xlog("===postpareSettings 1===");
	var user_show_greenzone = $('#settings_showGreenzone').is(':checked')?1:0;
	_sys.setLocalSetting("show_greenzone",user_show_greenzone);
	var settings_act_disrope = $('#settings_act_disrope').is(':checked')?1:0;
	_sys.setLocalSetting("settings_act_disrope",settings_act_disrope);
	var settings_act_rope = $('#settings_act_rope').is(':checked')?1:0;
	_sys.setLocalSetting("settings_act_rope",settings_act_rope);
	var settings_act_rope_login = $('#settings_userLogin').val();
	_sys.setLocalSetting("settings_act_rope_login",settings_act_rope_login);
	var settings_act_rope_password = $('#settings_userPassword').val();
	_sys.setLocalSetting("settings_act_rope_password",settings_act_rope_password);
	//xlog("===postpareSettings === settings_act_rope="+settings_act_rope+" settings_act_disrope="+settings_act_disrope);
}
// Should be called before opening options
function prepareSettings() {
	readSettings();
	var user_is_logged = coalesce(_sys.getLocalSetting("user_is_logged"),0);
	$('#settings_userLogin').val(user_login_email);
	$('#settings_userPassword').val(user_login_passw);
	$('#settings_showGreenzone').attr('checked', user_show_greenzone>0?true:false);
	$('#settings_act_disrope').attr('checked', true);
	_sys.setLocalSetting("settings_act_disrope",1);
	$('#settings_act_rope').attr('checked', false);
	_sys.setLocalSetting("settings_act_rope",0);
	var settings_act_rope = $('#settings_act_rope').is(':checked')?1:0;
	var settings_act_disrope = $('#settings_act_disrope').is(':checked')?1:0;
	if(user_is_logged == 0){
		// No login yet
		$("#settings_rope").hide();
		$("#settings_disrope").hide();
	}else if(user_login_type == _login_type_knownUser){
		$("#settings_rope").hide();
		$("#settings_disrope").show();
		$("#settings_disrope_email").html(user_login_email);
	}else{
		$("#settings_rope").show();
		$("#settings_disrope").hide();
	}
	//if(_sys.isDeveloper()){$('#settings_dbg').html("<textarea cols='35' rows='10'>"+xlog_get()+"</textarea>");}
}
// Should be called on options page init
function mainOptions() {
	_sys.startupOptions();
	prepareSettings();
}