/* based core.js */
function getHtml_DateHint(endate, htype)
{
	var answer = "";
	if(htype == 0){
		answer += "<span class='widget_title'>";
		answer += "<span class='widget_title_day'>"+_weekdays_long[endate.getDay()]+"</span>";
		answer += "<p class='widget_title_sub'>" + getHtml_DateHint2(endate)+"</p>";
		answer += "</span>";
	}
	if(htype == 2){
		answer += endate.getDate()+" "+_months_long[endate.getUTCMonth()]+", "+getHtml_DateHint2(endate);
	}
	//answer += dat+" "+monname;
	return answer;
}
function getHtml_DateHint2(endate)
{
	var answer = "";
	var dayendtime = moveDate2EndOfDay(new Date());
	var diff_days = getDateDiff(dayendtime,endate);
	//xlog("getHtml_DateHint2 dayendtime="+dayendtime+", endate="+endate+", diff_days="+diff_days);
	if(diff_days < 0){
		diff_days = 0;
	}
	if(diff_days < _daysort.length-1){
		answer += _daysort[diff_days];
	}else{
		answer += diff_days + _daysort[_daysort.length-1];
	}
	return answer;
}

function getHtml_Slider(slider_key, drink_id)
{
	var output="";
	output += "<div class='consumption' id='consumption_"+slider_key+"'>";
	//if(!_sys.isDocked()){
	//	output += "<table width='100%' cellspacing='0' cellpadding='0' border='0'><tr>";
	//		output += "<td class='consumption_drink' id='drink_"+slider_key+"' align='left'>&nbsp;</td>";//"+drink_name+"
	//		output += "<td class='consumption_amount' id='amount_"+slider_key+"' width='30px'></td><td class='consumption_amount_ml' width='30px'>&nbsp;"+$._b("LABEL.VOLUME_PRIM")+"</td>";
	//	output += "</table>";
	//}else
	{
		output += "<br>";
	}
	output += "<div class='control' id='slider_"+slider_key+"'></div>";
	output += "<div class='control_slider' id='control_slider_"+slider_key+"'></div>";
	output += "</div>";
	return output;
}

function updateSlider(slider_key, drink_id, slider_value)
{
	$('#amount_'+slider_key).html(slider_value);
	var c = getConsumptionValueColor( slider_value, drink_id);
	$('#slider_'+slider_key+' .ui-widget-header').css("background-color", c);
	
	var drink_name = escapeHtml(user_drink_data["drinks_list"][drink_id]["name"]);
	var strength = parseFloat(user_drink_data["drinks_list"][drink_id]["strength"]);
	var drink_alt = drink_name + ": " + parseInt(slider_value) + " " + $._b("LABEL.VOLUME_PRIM");
	$('#slider_'+slider_key+' a').attr('title',drink_alt);
}
function updateSliderBaloonPosX(params)
{
	return updateSliderBaloonPos(params.div_relto, params.div_what, params.xoff, params.yoff);
}
function updateSliderBaloonPos(div_relto, div_what, xoff, yoff)
{
	if(!div_relto){
		$(div_what).hide();
		return;
	}
	$div_rel = $(div_relto);
	if($div_rel.length == 0){
		//alert("NON!"+div_relto);
		$(div_what).hide();
		return;
	}
	$div_what = $(div_what);
	//get the position of the placeholder element
	var pos = $div_rel.offset();
	var width = $div_rel.width();

	$div_what.show();// Odd, but old safari can`t get width of hidden div!!!
	var width_what = $div_what.width();
	//show the menu directly over the placeholder
	if(!xoff){
		xoff = 0;
	}
	if(!yoff){
		yoff = 0;
	}
	$div_what.css( { "left": (pos.left + width/2 - width_what/2 + xoff) + "px", "top":(pos.top + yoff) + "px" } );//????
}

function initSlider(slider_key, drink_id, drink_value) {
	//initialization of one drink slider
	//alert("drink_id="+drink_id+" "+user_drink_data["drinks_list"][drink_id]);
	try{
		var slider_max = parseFloat(user_drink_data["drinks_list"][drink_id]["max_amount"]);
		var slider_step = parseFloat(user_drink_data["drinks_list"][drink_id]["step"]);
		var slider_value = parseFloat(drink_value);
		$('#slider_'+slider_key).slider({
			range: "min",
			value: slider_value,
			min: 0,
			max: slider_max,
			step: slider_step,
			animate: "fast",
			slide: function(event, ui) { //update amount label
				//if(_sys.isDocked())
				{
					$('#control_slider_'+slider_key).html(ui.value+" "+$._b("LABEL.VOLUME_PRIM"));
					updateSliderBaloonPos('#slider_'+slider_key+' a','#control_slider_'+slider_key,0,-20);
				}
				updateSlider(slider_key,drink_id,ui.value);
			},
			change: function(event, ui) {
				updateSliderBaloonPos(null,'#control_slider_'+slider_key);
				updateSlider(slider_key,drink_id,ui.value);
				if (ui.value >= $('#slider_'+slider_key).slider('option','max') * 0.98){
					enhanceSliderMax( '#slider_'+slider_key, ui.value * 1.3, ui.value );
				}
				var entry = user_lenta[user_current_entry];
				entry.drinks[drink_id] = ui.value;
				saveConsumption(slider_key, drink_id, ui.value);
			}
		});
		//set slider color and icon
		drink_text_id = user_drink_data["drinks_list"][drink_id]["text_id"];
		$('#slider_'+slider_key+' a').css('background','url("'+server_base_imgurl+'/img/drink/'+drink_text_id+'.gif") -4px 0px no-repeat');
		$('.disabled #slider_'+slider_key).slider('disable');
		updateSlider(slider_key,drink_id,slider_value);
	}catch(e){
		// Broken drinks?
		xlog("Broken drink found: "+drink_id+"; "+e.message);
	}
}

var dobler_preventer = {};
function saveConsumption(slider_key, drink_id, ui_value)
{
	$('#control_slider_'+slider_key).html(_inprogress_img);
	updateSliderBaloonPos('#slider_'+slider_key+' a','#control_slider_'+slider_key, -7, 0);
	delayCall(2000,updateSliderBaloonPosX,{div_relto:null,div_what:'#control_slider_'+slider_key});
	if(dobler_preventer[drink_id] == null || dobler_preventer[drink_id] != ui_value){
		dobler_preventer[drink_id] = ui_value;
		sendConsumption(drink_id,ui_value);
	}
	updateTotals();
}

function initNote()
{
	// Note editing fixes
	var entry = user_lenta[user_current_entry];
	var note_e = entry.note;
	var emp_note_text = $._b("LABEL.EMPTY_DAY_NOTE");
	entry.note_empty = false;
	if(!note_e || note_e.length==0){
		entry.note_empty = true;
		note_e = emp_note_text;
	}
	$("#entry_note").val(note_e);
	$("#entry_note").focus(
		function(e){
			if(entry.note_empty){
				entry.note_empty=false;
				$("#entry_note").val("");
			}
		}
	);
	$("#entry_note").blur(
		function(e){
			var nw = $("#entry_note").val();
			if(nw == ""){
				entry.note_empty=true;
				$("#entry_note").val(emp_note_text);
			}
		}
	);
	var updenf = function(e){
		var $enotediv = $("#entry_note");
		var enot = $enotediv.val();
		if(enot != "" && enot != emp_note_text){
			if(e == null || e == true){
				$(".date_note_submit").show();
				if(!$enotediv.hasClass("date_note_focus")){
					$enotediv.addClass("date_note_focus");
				}
			}
			if(!$enotediv.hasClass("date_note_text")){
				$enotediv.addClass("date_note_text");
			}
		} else {
			$enotediv.removeClass("date_note_text");
		}
	}
	$("#entry_note").change(function(e){saveNotePrepare(e)});
	$("#entry_note").keyup(function(e){ if (e.keyCode == 13) {saveNotePrepare(e);}else{updenf();}});
	updenf(false);
}

function saveNotePrepare(e)
{
	var entry = user_lenta[user_current_entry];
	$('#control_slider_note').html(_inprogress_img);
	updateSliderBaloonPos('#entry_note','#control_slider_note',0,-20);
	delayCall(2000,updateSliderBaloonPosX,{div_relto:null,div_what:'#control_slider_note'});
	delayCall(2000,saveNoteFinalize,null);
	entry.note = $("#entry_note").val();
	if(user_note_save_queue.length == 0 || user_note_save_queue[user_note_save_queue.length-1] != entry){
		user_note_save_queue.push(entry);
		delayCall(1000,saveNote,null);
	}
}

function saveNoteFinalize(e)
{
	var $enotediv = $("#entry_note");
	$(".date_note_submit").hide();
	$enotediv.removeClass("date_note_focus");
}

function saveNote(e)
{
	if(user_note_save_queue.length == 0){
		return;
	}
	var entry = user_note_save_queue[user_note_save_queue.length-1];
	user_note_save_queue = [];
	sendNote(entry.entry_date,entry.note);
}

function enhanceSliderMax( slider_entity, new_max, value_to_set) {

	if (isNaN(new_max) || isNaN(value_to_set)){
		return false;
	}

	new_max = Math.round(new_max);
	value_to_set = Math.round(value_to_set);

	//update slider
	$( slider_entity ).slider('option', 'max', new_max);
	$( slider_entity ).slider('value', value_to_set, true );	
	
	//TBD: and save to user preferences
}

function getConsumptionValueColor(amount, drink_id) {
	//black_point is the volume of pure spirit where black zone starts
	//returns the color value from green (0) through yellow, red to black
	var strength = parseFloat(user_drink_data["drinks_list"][drink_id]["strength"]);
	return getGradientColor(amount,strength,_black_slider_point);
}

function drinking_unit_approximation( unit_name, unit_volume, ml )
	//returns correct plurar name for drinking units
	//RU only
{
	var drinking_unit_settings = {
		lang: {
			mug: ['кружка', 'кружки', 'кружек'],
			glass: ['бокал', 'бокала', 'бокалов'],
			shot: ['рюмка', 'рюмки', 'рюмок'],
			can: ['банка', 'банки', 'банок'],
			cocktaillongdrink: ['порция', 'порции', 'порций'],
			cocktailshot: ['шот', 'шота', 'шотов'],
			plural:  function(n) {
				return (n % 10 == 1 && n % 100 != 11 ? 0 : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2);
			}
		}
	};
	
	var number_of = Math.round( ml/unit_volume );
	if (number_of){
		return "? " + number_of.toString() + " " + drinking_unit_settings.lang[unit_name][ drinking_unit_settings.lang.plural( number_of ) ];
	}else{ //0
		return '';
	}
}

/*
function calendarDaySetHandlers( userID, date, volume_unit_name, black_point, drinks_to_exclude ) {
	//this function sets notes and 'all drinks' handlers. function is called after sliders are initialized.
	
	updateTotalConsumptionSpiritEq( date, 'link-'+date, volume_unit_name, black_point);
		
	$('#display_all_drinks_link_'+date).click( function() {

		$(this).hide();
		$("#favourite_drinks_hint_"+date).show();
		$('#display_all_drinks_'+date).load('/ajax.php?display_others&date='+date+'&exclude='+drinks_to_exclude+'&userID='+userID+'&yeme_type='+$('#yeme_type').val(), function(){
			$('#consumptions_'+date+' .consumption .hidden').show();
			$("#loading_other_drinks_"+date).hide();
		});


	});

	$('#note-text-'+date).focus(function(){
	
		if ($('#'+date+' .note-submit img:visible').length)
			return;
		
		if ( !$('#note-submit-'+date+':visible').length )
		{

			if ( $('#note-text-'+date).hasClass('blank-note') )
			{
				$('#note-text-'+date).val('');
				$('#note-text-'+date).removeClass('blank-note');
				$('#note-text-'+date).css({"color": "#000", "font-style": "normal", "font-weight": "bold"});
			}
						
			//don't use .animate here because FF looses focus when this is used
			var h = 23;
			$('#'+date+' .note').height( $('#'+date+' .note').height()+h );
			$('#'+date).height( $('#'+date).height()+h );
			updateScrollHeight( $('#'+date).height() );

			$('#note-submit-'+date).show();			
			
		}
						
	});


	$('#note-text-'+date).keyup(function(){
					
		if ( $('#note-text-'+date).val().length > 255 )
		{
			$('#note-'+date+' em').show();
		}
		else
		{
			$('#note-'+date+' em').hide();
		}
						
	});


	$('#note-'+date).submit(function(){
		saveNote( date, $('#note-text-'+date).val(), userID, $('#note-email-'+date).val() );
		return false;
	});

	updateScrollHeight( $('#'+date).height()+10 );

}
*/
